"use strict";
// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
Object.defineProperty(exports, "__esModule", { value: true });
exports.urlBase64ToUint8Array = void 0;
const log_js_1 = require("../common/log.js");
const { error } = log_js_1.Logger("zeed:base64");
function urlBase64ToUint8Array(base64String) {
    try {
        let padding = "=".repeat((4 - (base64String.length % 4)) % 4);
        let base64 = (base64String + padding).replace(/-/g, "+").replace(/_/g, "/");
        let rawData = window.atob(base64);
        let outputArray = new Uint8Array(rawData.length);
        for (let i = 0; i < rawData.length; ++i) {
            outputArray[i] = rawData.charCodeAt(i);
        }
        return outputArray;
    }
    catch (err) {
        error(err, base64String);
    }
}
exports.urlBase64ToUint8Array = urlBase64ToUint8Array;
//# sourceMappingURL=base64.js.map