export declare function arrayUnique<T>(x: T[]): T[];
export declare function arrayMinus<T>(x: T[], y: T[]): T[];
export declare function arrayUnion<T>(...a: T[][]): T[];
/** `[1,[2,3]]` becomes `[1,2,3]` */
export declare function arrayFlatten<T>(list: (T | T[])[]): T[];
export declare function arrayIntersection<T>(x: T[], y: T[]): T[];
export declare function arraySymmetricDifference<T>(x: T[], y: T[]): T[];
export declare function arrayRemoveElement<T>(arr: T[], el: T): T[];
/** Only have it once in the set */
export declare function arraySetElement<T>(arr: T[], el: T): T[];
export declare function arrayFilterInPlace<T>(array: T[], fn: (el: T) => boolean): T[];
export declare function arrayToggleInPlace<T>(array: T[], el: T): T[];
export declare function arrayEmptyInPlace<T>(array: T[]): T[];
export declare function arraySorted<T>(arr: Iterable<T> | ArrayLike<T>, cond?: ((a: T, b: T) => number) | undefined): T[];
export declare function arraySortedNumbers(arr: number[]): number[];
export declare function arrayIsEqual<T>(array1: T[], array2: T[]): boolean;
export declare function arrayShuffleInPlace<T>(array: T[]): T[];
export declare function arrayShuffle<T>(array: T[]): T[];
/** Randomly shuffle the order of the array's elements. Force to have a different order if array has more than one element. */
export declare function arrayShuffleForce<T>(array: T[]): T[];
export declare function arrayRandomElement<T>(array: T[]): T;
