import { Emitter } from "./emitter.js";
/** See http://developer.mozilla.org/en-US/docs/Web/API/MessageEvent */
export interface ChannelMessageEvent {
    data: any;
    origin?: string;
    lastEventId?: string;
}
/**
 * Inspired by
 * http://developer.mozilla.org/en-US/docs/Web/API/BroadcastChannel
 * https://deno.com/deploy/docs/runtime-broadcast-channel
 * */
export declare abstract class Channel extends Emitter<{
    message(event: ChannelMessageEvent): void;
    messageerror(event: ChannelMessageEvent): void;
}> {
    abstract postMessage(data: any): void;
    close(): void;
}
/** Very basic channel demonstrating local communication */
export declare class LocalChannel extends Channel {
    other?: LocalChannel;
    postMessage(data: any): void;
}
/** Channel that requires  */
export declare class CommandChannel {
}
