"use strict";
// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandChannel = exports.LocalChannel = exports.Channel = void 0;
const log_js_1 = require("./log.js");
const emitter_js_1 = require("./emitter.js");
const utils_js_1 = require("./utils.js");
const uuid_js_1 = require("./uuid.js");
const log = log_js_1.Logger("zeed:channel");
/**
 * Inspired by
 * http://developer.mozilla.org/en-US/docs/Web/API/BroadcastChannel
 * https://deno.com/deploy/docs/runtime-broadcast-channel
 * */
class Channel extends emitter_js_1.Emitter {
    close() { }
}
exports.Channel = Channel;
/** Very basic channel demonstrating local communication */
class LocalChannel extends Channel {
    postMessage(data) {
        var _a;
        (_a = this.other) === null || _a === void 0 ? void 0 : _a.emit("message", {
            data: utils_js_1.cloneObject(data),
            origin: "local",
            lastEventId: uuid_js_1.uuid(),
        });
    }
}
exports.LocalChannel = LocalChannel;
/** Channel that requires  */
class CommandChannel {
}
exports.CommandChannel = CommandChannel;
// export class Channel {
//   _name = uname(this.constructor.name)
//   _channel?: ChannelTransport
//   // _subscriber
//   buffer: Data[] = []
//   constructor(channel?: SimpleChannel) {
//     if (channel) {
//       this.connect(channel)
//     }
//   }
//   _connectChannel() {
//     log("_connectChannel Channel")
//     this.publishBuffered()
//   }
//   connect(channel: SimpleChannel) {
//     log.assert(channel, "Channel missing")
//     this._channel = channel
//     this._connectChannel()
//   }
//   publishBuffered() {
//     if (this.isConnected()) {
//       log("publishBuffered", this._name)
//       this.buffer.forEach((data) => {
//         log("send buffered", this._name, data)
//         this.send(data)
//       })
//       this.buffer = []
//     }
//   }
//   disconnect() {
//     // this._subscriber = undefined // ?
//     this._channel = undefined
//   }
//   isConnected() {
//     return this._channel != null
//   }
//   encode(obj: Json): Data {
//     return JSON.stringify(obj) // e.g. JSON.stringify
//   }
//   decode(obj: Data): Json {
//     return JSON.parse(obj as string) // e.g. JSON.parse
//   }
//   publish(obj: Json) {
//     const data = this.encode(obj)
//     if (this.isConnected()) {
//       this.send(data)
//     } else {
//       this.buffer.push(data)
//     }
//   }
//   subscribe(fn) {
//     this._subscriber = fn
//   }
//   receive(data: Data) {
//     log("receive", this._name, data)
//     let obj = this.decode(data)
//     if (this._subscriber) {
//       this._subscriber(obj)
//     }
//   }
//   // Override this in a subclass!
//   send(data: Data) {
//     log("send", this._name, data)
//     // this._channel.postMessage(payload)
//     this._channel.receive(data)
//   }
// }
// const HANDSHAKE_PING = "__handshake__ping__"
// const HANDSHAKE_PONG = "__handshake__pong__"
// export class HandshakeChannel extends Channel {
//   _handshake = false
//   isConnected(): boolean {
//     return this._handshake
//   }
//   _connectChannel() {
//     log("_connectChannel HandshakeChannel", this._name)
//     // super._connectChannel()
//     this.send(HANDSHAKE_PING)
//   }
//   receive(data) {
//     log("receive", this._name, data)
//     if (data === HANDSHAKE_PING) {
//       if (this._channel) {
//         this.send(HANDSHAKE_PONG)
//         this._handshake = true
//         this.publishBuffered()
//       }
//     } else if (data === HANDSHAKE_PONG) {
//       if (!this._handshake) {
//         this._handshake = true
//         this.publishBuffered()
//       }
//     } else {
//       super.receive(data)
//     }
//   }
// }
// export class PostChannel extends HandshakeChannel {
//   _connectChannel() {
//     this._channel.addEventListener("message", (e: MessageEvent) =>
//       this.receive(e.data)
//     )
//     super._connectChannel()
//   }
//   send(data) {
//     log("send postChannel", this._name, data)
//     this._channel.postMessage(data)
//   }
//   // Proxy?
//   // Heartbeat?
//   // Error and disconnect handling?
// }
// export class JSONPostChannel extends PostChannel {
//   encode(obj: Json): string {
//     return JSON.stringify(obj)
//   }
//   decode(obj: string): Json {
//     return JSON.parse(obj)
//   }
// }
//# sourceMappingURL=channel.js.map