export declare type EmitterHandler = (...objs: any[]) => void;
export declare type EmitterAllHandler<T = string> = (key: T, ...objs: any[]) => void;
export declare type ListenerSignature<L> = {
    [E in keyof L]: (...args: any[]) => any;
};
export declare type DefaultListener = {
    [k: string]: (...args: any[]) => any;
};
export declare class Emitter<L extends ListenerSignature<L> = DefaultListener> {
    subscribers: any;
    subscribersOnAny: any[];
    emit<U extends keyof L>(event: U, ...args: Parameters<L[U]>): Promise<boolean>;
    onAny(fn: EmitterHandler): void;
    on<U extends keyof L>(event: U, listener: L[U]): {
        cleanup: () => void;
    };
    once<U extends keyof L>(event: U, listener: L[U]): void;
    off<U extends keyof L>(event: U, listener: L[U]): this;
    removeAllListeners(event?: keyof L): this;
}
declare global {
    interface ZeedGlobalContext {
        emitter?: Emitter;
    }
    interface ZeedGlobalEmitter {
    }
}
/** Global emitter that will listen even across modules */
export declare function getGlobalEmitter(): Emitter<ZeedGlobalEmitter>;
export declare const messages: Emitter<DefaultListener>;
export declare function lazyListener(emitter: any, listenerKey?: string): (key?: string, skipUnmatched?: boolean) => Promise<any>;
