"use strict";
// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMutex = void 0;
function createMutex() {
    let token = true;
    return (fn, elseFn) => {
        let executed = false;
        if (token) {
            token = false;
            try {
                fn();
                executed = true;
            }
            finally {
                token = true;
            }
        }
        else if (elseFn !== undefined) {
            elseFn();
        }
        return executed;
    };
}
exports.createMutex = createMutex;
// export type Lock = ({lock: () => Promise<void>, unlock: () => void})
// export function createLock() {
//   let lockCtr = []
//   return {
//     lock() {
//     },
//     unlock() {
//     }
//   }
// }
//# sourceMappingURL=mutex.js.map