"use strict";
// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortedOrderby = exports.cmp = exports.composeOrderby = exports.parseOrderby = void 0;
function parseOrderby(value = "") {
    let [field = "", orderby = "asc"] = value.split(" ");
    orderby = orderby.toLowerCase();
    return {
        field,
        orderby,
        asc: orderby !== "desc",
        desc: orderby === "desc",
    };
}
exports.parseOrderby = parseOrderby;
function composeOrderby(field, asc = true) {
    return `${field} ${asc ? "asc" : "desc"}`;
}
exports.composeOrderby = composeOrderby;
// Classic compare function with direction flag
function cmp(a, b, asc = true) {
    const aa = a || 0;
    const bb = b || 0;
    return aa > bb ? (asc ? 1 : -1) : aa < bb ? (asc ? -1 : 1) : 0;
}
exports.cmp = cmp;
function sortedOrderby(values, ...orderby) {
    if (orderby.length > 0) {
        let orderByList = orderby.map(parseOrderby);
        // let { field, asc } = parseOrderby(orderby)
        //if (field != null && typeof field === "string") {
        // let bigger = asc ? 1 : -1
        // let smaller = asc ? -1 : 1
        let sortValues = Array.from(values);
        sortValues.sort((a, b) => {
            for (let { field, asc } of orderByList) {
                const result = cmp(a[field], b[field], asc);
                if (result !== 0)
                    return result;
            }
            return 0;
            // const aa = a[field] || 0
            // const bb = b[field] || 0
            // return aa > bb ? bigger : aa < bb ? smaller : 0
        });
        return sortValues;
    }
    return values;
}
exports.sortedOrderby = sortedOrderby;
//# sourceMappingURL=orderby.js.map