interface Task {
    id: string;
    info: any;
    added?: number;
    started?: number;
    ended?: number;
    response?: string;
}
export declare function now(): number;
export declare class TaskHandler {
    _tasks: Task[];
    _name: string;
    _fn: Function;
    _waitFn?: Function;
    _delayTimer: any;
    defer: number;
    debounce: number;
    persist: boolean;
    latest: boolean;
    batch: number;
    filter?: (v: any) => boolean;
    sort?: any;
    merge?: any;
    queue?: TaskQueue;
    constructor(name: string, fn: (info: any) => any, { queue, defer, debounce, persist, latest, batch, filter, sort, merge, }?: {
        queue?: null | undefined;
        defer?: number | undefined;
        debounce?: number | undefined;
        persist?: boolean | undefined;
        latest?: boolean | undefined;
        batch?: number | undefined;
        filter?: undefined;
        sort?: undefined;
        merge?: undefined;
    });
    response(task: Task, info: any, error: any): void;
    isEmpty(): boolean;
    remove(taskID: string): void;
    _performNext(): Promise<void>;
    force(): Promise<void>;
    _persist(): void;
    _restore(): void;
    add(info: any, { id, ...props }?: {
        id?: string | undefined;
    }): Task;
    wait(): Promise<unknown>;
    destroy(): void;
}
export declare class TaskQueue {
    _name: string;
    _handlers: {
        [key: string]: any;
    };
    constructor({ name }?: {
        name?: string | undefined;
    });
    on(name: string, fn: (info: any) => any, opt?: {
        queue?: null | undefined;
        defer?: number | undefined;
        debounce?: number | undefined;
        persist?: boolean | undefined;
        latest?: boolean | undefined;
        batch?: number | undefined;
        filter?: null | undefined;
        sort?: null | undefined;
        merge?: null | undefined;
    } | undefined): TaskHandler;
    off(name: string): void;
    once(name: string, fn: (info: any) => any): void;
    _emit(name: string | number, info: any, props?: {}): any;
    emit(name: string, info: any, props?: {}): any;
    fetch(name: string, info: string): Promise<any>;
    handler(name: string): TaskHandler | undefined;
    wait(name?: string): Promise<void>;
}
export {};
